% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/games.R
\name{asymmetric.preference.game}
\alias{asymmetric.preference.game}
\title{Trait-based random generation}
\usage{
asymmetric.preference.game(
  nodes,
  types,
  type.dist.matrix = matrix(1, types, types),
  pref.matrix = matrix(1, types, types),
  loops = FALSE
)
}
\arguments{
\item{nodes}{The number of vertices in the graphs.}

\item{types}{The number of different vertex types.}

\item{type.dist.matrix}{The joint distribution of the in- and out-vertex
types.}

\item{pref.matrix}{A square matrix giving the preferences of the vertex
types. The matrix has \sQuote{types} rows and columns. When generating
an undirected graph, it must be symmetric.}

\item{loops}{Logical constant, whether self-loops are allowed in the graph.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{asymmetric.preference.game()} was renamed to \code{sample_asym_pref()} to create a more
consistent API.
}
\keyword{internal}
