% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/centralization.R
\name{centralization.evcent}
\alias{centralization.evcent}
\title{Centralize a graph according to the eigenvector centrality of vertices}
\usage{
centralization.evcent(
  graph,
  directed = FALSE,
  scale = TRUE,
  options = arpack_defaults(),
  normalized = TRUE
)
}
\arguments{
\item{graph}{The input graph.}

\item{directed}{logical scalar, whether to use directed shortest paths for
calculating eigenvector centrality.}

\item{scale}{Whether to rescale the eigenvector centrality scores, such that
the maximum score is one.}

\item{options}{This is passed to \code{\link[=eigen_centrality]{eigen_centrality()}}, the options
for the ARPACK eigensolver.}

\item{normalized}{Logical scalar. Whether to normalize the graph level
centrality score by dividing by the theoretical maximum.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{centralization.evcent()} was renamed to \code{centr_eigen()} to create a more
consistent API.
}
\keyword{internal}
