% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/console.R
\name{console}
\alias{console}
\alias{.igraph.progress}
\alias{.igraph.status}
\title{The igraph console}
\usage{
console()

.igraph.progress(percent, message, clean = FALSE)

.igraph.status(message)
}
\arguments{
\item{percent, message, clean}{Used internally by \code{.igraph.progress()} and \code{.igraph.status()}}
}
\value{
\code{NULL}, invisibly.
}
\description{
The igraph console is a GUI window that shows what the currently running
igraph function is doing.
}
\details{
The console can be started by calling the \code{console()} function.
Then it stays open, until the user closes it.

Another way to start it to set the \code{verbose} igraph option to
\dQuote{tkconsole} via \code{igraph_options()}. Then the console (re)opens
each time an igraph function supporting it starts; to close it, set the
\code{verbose} option to another value.

The console is written in Tcl/Tk and required the \code{tcltk} package.
}
\seealso{
\code{\link[=igraph_options]{igraph_options()}} and the \code{verbose} option.
}
\author{
Gabor Csardi \email{csardi.gabor@gmail.com}
}
\concept{console}
\keyword{graphs}
