% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/components.R
\name{decompose.graph}
\alias{decompose.graph}
\title{Decompose a graph into components}
\usage{
decompose.graph(
  graph,
  mode = c("weak", "strong"),
  max.comps = NA,
  min.vertices = 0
)
}
\arguments{
\item{graph}{The original graph.}

\item{mode}{Character constant giving the type of the components, wither
\code{weak} for weakly connected components or \code{strong} for strongly
connected components.}

\item{max.comps}{The maximum number of components to return. The first
\code{max.comps} components will be returned (which hold at least
\code{min.vertices} vertices, see the next parameter), the others will be
ignored. Supply \code{NA} here if you don't want to limit the number of
components.}

\item{min.vertices}{The minimum number of vertices a component should
contain in order to place it in the result list. E.g. supply 2 here to ignore
isolate vertices.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{decompose.graph()} was renamed to \code{decompose()} to create a more
consistent API.
}
\keyword{internal}
