% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/interface.R
\name{delete_edges}
\alias{delete_edges}
\title{Delete edges from a graph}
\usage{
delete_edges(graph, edges)
}
\arguments{
\item{graph}{The input graph.}

\item{edges}{The edges to remove, specified as an edge sequence. Typically
this is either a numeric vector containing edge IDs, or a character vector
containing the IDs or names of the source and target vertices, separated by
\code{|}}
}
\value{
The graph, with the edges removed.
}
\description{
Delete edges from a graph
}
\examples{
g <- make_ring(10) \%>\%
  delete_edges(seq(1, 9, by = 2))
g

g <- make_ring(10) \%>\%
  delete_edges("10|1")
g

g <- make_ring(5)
g <- delete_edges(g, get.edge.ids(g, c(1, 5, 4, 5)))
g
}
\seealso{
Other functions for manipulating graph structure: 
\code{\link{+.igraph}()},
\code{\link{add_edges}()},
\code{\link{add_vertices}()},
\code{\link{complementer}()},
\code{\link{compose}()},
\code{\link{connect}()},
\code{\link{contract}()},
\code{\link{delete_vertices}()},
\code{\link{difference}()},
\code{\link{difference.igraph}()},
\code{\link{disjoint_union}()},
\code{\link{edge}()},
\code{\link{igraph-minus}},
\code{\link{intersection}()},
\code{\link{intersection.igraph}()},
\code{\link{path}()},
\code{\link{permute}()},
\code{\link{rep.igraph}()},
\code{\link{reverse_edges}()},
\code{\link{simplify}()},
\code{\link{union}()},
\code{\link{union.igraph}()},
\code{\link{vertex}()}
}
\concept{functions for manipulating graph structure}
