% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/conversion.R
\name{get.adjlist}
\alias{get.adjlist}
\title{Adjacency lists}
\usage{
get.adjlist(
  graph,
  mode = c("all", "out", "in", "total"),
  loops = c("twice", "once", "ignore"),
  multiple = TRUE
)
}
\arguments{
\item{graph}{The input graph.}

\item{mode}{Character scalar, it gives what kind of adjacent edges/vertices
to include in the lists. \sQuote{\code{out}} is for outgoing edges/vertices,
\sQuote{\verb{in}} is for incoming edges/vertices, \sQuote{\code{all}} is
for both. This argument is ignored for undirected graphs.}

\item{loops}{Character scalar, one of \code{"ignore"} (to omit loops), \code{"twice"}
(to include loop edges twice) and \code{"once"} (to include them once). \code{"twice"}
is not allowed for directed graphs and will be replaced with \code{"once"}.}

\item{multiple}{Logical scalar, set to \code{FALSE} to use only one representative
of each set of parallel edges.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{get.adjlist()} was renamed to \code{as_adj_list()} to create a more
consistent API.
}
\keyword{internal}
