% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/structural.properties.R
\name{graph.laplacian}
\alias{graph.laplacian}
\title{Graph Laplacian}
\usage{
graph.laplacian(
  graph,
  normalized = FALSE,
  weights = NULL,
  sparse = igraph_opt("sparsematrices")
)
}
\arguments{
\item{graph}{The input graph.}

\item{normalized}{Whether to calculate the normalized Laplacian. See
definitions below.}

\item{weights}{An optional vector giving edge weights for weighted Laplacian
matrix. If this is \code{NULL} and the graph has an edge attribute called
\code{weight}, then it will be used automatically. Set this to \code{NA} if
you want the unweighted Laplacian on a graph that has a \code{weight} edge
attribute.}

\item{sparse}{Logical scalar, whether to return the result as a sparse
matrix. The \code{Matrix} package is required for sparse matrices.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{graph.laplacian()} was renamed to \code{laplacian_matrix()} to create a more
consistent API.
}
\keyword{internal}
