% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifs.R
\name{graph.motifs.est}
\alias{graph.motifs.est}
\title{Graph motifs}
\usage{
graph.motifs.est(
  graph,
  size = 3,
  cut.prob = rep(0, size),
  sample.size = vcount(graph)/10,
  sample = NULL
)
}
\arguments{
\item{graph}{Graph object, the input graph.}

\item{size}{The size of the motif, currently size 3 and 4 are supported
in directed graphs and sizes 3-6 in undirected graphs.}

\item{cut.prob}{Numeric vector giving the probabilities that the search
graph is cut at a certain level. Its length should be the same as the size
of the motif (the \code{size} argument). By default no cuts are made.}

\item{sample.size}{The number of vertices to use as a starting point for
finding motifs. Only used if the \code{sample} argument is \code{NULL}.}

\item{sample}{If not \code{NULL} then it specifies the vertices to use as a
starting point for finding motifs.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{graph.motifs.est()} was renamed to \code{sample_motifs()} to create a more
consistent API.
}
\keyword{internal}
