% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hrg.R
\name{hrg.consensus}
\alias{hrg.consensus}
\title{Create a consensus tree from several hierarchical random graph models}
\usage{
hrg.consensus(graph, hrg = NULL, start = FALSE, num.samples = 10000)
}
\arguments{
\item{graph}{The graph the models were fitted to.}

\item{hrg}{A hierarchical random graph model, in the form of an
\code{igraphHRG} object. \code{consensus_tree()} allows this to be
\code{NULL} as well, then a HRG is fitted to the graph first, from a
random starting point.}

\item{start}{Logical, whether to start the fitting/sampling from the
supplied \code{igraphHRG} object, or from a random starting point.}

\item{num.samples}{Number of samples to use for consensus generation or
missing edge prediction.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{hrg.consensus()} was renamed to \code{consensus_tree()} to create a more
consistent API.
}
\keyword{internal}
