% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/centrality.R
\name{hub.score}
\alias{hub.score}
\title{Kleinberg's hub and authority centrality scores.}
\usage{
hub.score(graph, scale = TRUE, weights = NULL, options = arpack_defaults())
}
\arguments{
\item{graph}{The input graph.}

\item{scale}{Logical scalar, whether to scale the result to have a maximum
score of one. If no scaling is used then the result vector has unit length
in the Euclidean norm.}

\item{weights}{Optional positive weight vector for calculating weighted
scores. If the graph has a \code{weight} edge attribute, then this is used
by default.
This function interprets edge weights as connection strengths. In the
random surfer model, an edge with a larger weight is more likely to be
selected by the surfer.}

\item{options}{A named list, to override some ARPACK options. See
\code{\link[=arpack]{arpack()}} for details.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{hub.score()} was renamed to \code{hub_score()} to create a more
consistent API.
}
\keyword{internal}
