% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/degseq.R
\name{is.graphical.degree.sequence}
\alias{is.graphical.degree.sequence}
\title{Is a degree sequence graphical?}
\usage{
is.graphical.degree.sequence(
  out.deg,
  in.deg = NULL,
  allowed.edge.types = c("simple", "loops", "multi", "all")
)
}
\arguments{
\item{out.deg}{Integer vector, the degree sequence for undirected graphs, or
the out-degree sequence for directed graphs.}

\item{in.deg}{\code{NULL} or an integer vector. For undirected graphs, it
should be \code{NULL}. For directed graphs it specifies the in-degrees.}

\item{allowed.edge.types}{The allowed edge types in the graph. \sQuote{simple}
means that neither loop nor multiple edges are allowed (i.e. the graph must be
simple). \sQuote{loops} means that loop edges are allowed but mutiple edges
are not. \sQuote{multi} means that multiple edges are allowed but loop edges
are not. \sQuote{all} means that both loop edges and multiple edges are
allowed.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{is.graphical.degree.sequence()} was renamed to \code{is_graphical()} to create a more
consistent API.
}
\keyword{internal}
