% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/community.R
\name{multilevel.community}
\alias{multilevel.community}
\title{Finding community structure by multi-level optimization of modularity}
\usage{
multilevel.community(graph, weights = NULL, resolution = 1)
}
\arguments{
\item{graph}{The input graph.}

\item{weights}{The weights of the edges. It must be a positive numeric vector,
\code{NULL} or \code{NA}. If it is \code{NULL} and the input graph has a
\sQuote{weight} edge attribute, then that attribute will be used. If
\code{NULL} and no such attribute is present, then the edges will have equal
weights. Set this to \code{NA} if the graph was a \sQuote{weight} edge
attribute, but you don't want to use it for community detection. A larger
edge weight means a stronger connection for this function.}

\item{resolution}{Optional resolution parameter that allows the user to
adjust the resolution parameter of the modularity function that the algorithm
uses internally. Lower values typically yield fewer, larger clusters. The
original definition of modularity is recovered when the resolution parameter
is set to 1.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{multilevel.community()} was renamed to \code{cluster_louvain()} to create a more
consistent API.
}
\keyword{internal}
