% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/games.R
\name{sbm.game}
\alias{sbm.game}
\title{Sample stochastic block model}
\usage{
sbm.game(n, pref.matrix, block.sizes, directed = FALSE, loops = FALSE)
}
\arguments{
\item{n}{Number of vertices in the graph.}

\item{pref.matrix}{The matrix giving the Bernoulli rates.  This is a
\eqn{K\times K}{KxK} matrix, where \eqn{K} is the number of groups. The
probability of creating an edge between vertices from groups \eqn{i} and
\eqn{j} is given by element \eqn{(i,j)}. For undirected graphs, this matrix
must be symmetric.}

\item{block.sizes}{Numeric vector giving the number of vertices in each
group. The sum of the vector must match the number of vertices.}

\item{directed}{Logical scalar, whether to generate a directed graph.}

\item{loops}{Logical scalar, whether self-loops are allowed in the graph.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{sbm.game()} was renamed to \code{sample_sbm()} to create a more
consistent API.
}
\keyword{internal}
