% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/operators.R
\name{union}
\alias{union}
\title{Union of two or more sets}
\usage{
union(...)
}
\arguments{
\item{...}{Arguments, their number and interpretation depends on
the function that implements \code{union()}.}
}
\value{
Depends on the function that implements this method.
}
\description{
This is an S3 generic function. See \code{methods("union")}
for the actual implementations for various S3 classes. Initially
it is implemented for igraph graphs and igraph vertex and edge
sequences. See
\code{\link[=union.igraph]{union.igraph()}}, and
\code{\link[=union.igraph.vs]{union.igraph.vs()}}.
}
\seealso{
Other functions for manipulating graph structure: 
\code{\link{+.igraph}()},
\code{\link{add_edges}()},
\code{\link{add_vertices}()},
\code{\link{complementer}()},
\code{\link{compose}()},
\code{\link{connect}()},
\code{\link{contract}()},
\code{\link{delete_edges}()},
\code{\link{delete_vertices}()},
\code{\link{difference}()},
\code{\link{difference.igraph}()},
\code{\link{disjoint_union}()},
\code{\link{edge}()},
\code{\link{igraph-minus}},
\code{\link{intersection}()},
\code{\link{intersection.igraph}()},
\code{\link{path}()},
\code{\link{permute}()},
\code{\link{rep.igraph}()},
\code{\link{reverse_edges}()},
\code{\link{simplify}()},
\code{\link{union.igraph}()},
\code{\link{vertex}()}
}
\concept{functions for manipulating graph structure}
